local REC = CreateFrame("Frame")

REC:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
REC:RegisterEvent("ADDON_LOADED")

local Gender = {" she ", " he ", " her ", " his ", " she's ", " he's ",}

local EMOTE_TRIGGERS_REPLIES = {}

function REC:New(trigger, reply)
	tinsert(EMOTE_TRIGGERS_REPLIES, {Trigger = Remote_TRIGGERS[trigger], Reply = Remote_REPLIES[reply]})
end

function REC:DelayTimer(REPLY, SENDER)
	local time = 0
	REC:SetScript("OnUpdate", function(self, elapsed) 
		time = time + elapsed
		if time > Remote_SETTINGS.delay then
			DoEmote(REPLY, SENDER, true);
			REC:SetScript("OnUpdate", nil)
		end
	end)
end

REC.ResetHandler = CreateFrame("Frame")
function REC:Reset_Send_Limit()
	local time = 0
	REC.ResetHandler:SetScript("OnUpdate", function(self, elapsed) 
		time = time + elapsed
		if time > 8 then	
			REC.prev_Trigger = nil
			REC.ResetHandler:SetScript("OnUpdate", nil)
		end
	end)
end

function REC:CHAT_MSG_TEXT_EMOTE(event, message, sender, ...)

	if ... and (sender ~= UnitName("player")) and string.find(message, "you") then
		for i, v in pairs(EMOTE_TRIGGERS_REPLIES) do
			for _, sex in pairs(Gender) do
				if string.find(message, sex) then
					message = string.gsub(message, " SEX ", sex)
				end
			end
			message = string.gsub(message, sender, "REPLACETHIS")
			if (Remote_SETTINGS.faction) and UnitIsEnemy("player", sender) then
				if (REC.prev_Trigger ~= (Remote_SETTINGS.faction)) then
					if REC.prev_Trigger ~= "SHRUG" and REC.prev_Trigger ~= "PONDER" then
						REC:DelayTimer(Remote_SETTINGS.faction, sender)
					end
					REC.prev_Trigger = (Remote_SETTINGS.faction)
				end
			elseif message == v.Trigger then
				if REC.prev_Trigger ~= v.Trigger  then
					REC:DelayTimer(v.Reply, sender)
					REC.prev_Trigger = v.Trigger
				end
			end
			REC:Reset_Send_Limit()
		end
	end
end

function REC.Load(self)
	Remote_SV = Remote_SV or REC.GetDefaults()
	Remote_SETTINGS = Remote_SETTINGS or {delay = .75}
	REC:Options()
	
	print("Remote: Version ".. GetAddOnMetadata('Remote', 'Version') .." Loaded!".."  (Type /REC for options)");

	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self:SetScript("OnEvent", function(self, event, message, sender, ...)
		self:CHAT_MSG_TEXT_EMOTE(event, message, sender, ...)
	end)

	
	
	SLASH_Remote1 = '/remote'
	local function handler(msg, editbox)
		REC:ShowOptions()
	end
	SlashCmdList['Remote'] = handler
end

function REC:ShowOptions()

	REC.options:Hide()
	REC.options:Show()
	InterfaceOptionsFrame:Show()
	InterfaceOptionsFrame_OpenToCategory(REC.options)
end

function REC.GetDefaults()
	return {
		CHICKEN = "THREATEN",
		GOLFCLAP = "SMIRK",
		WINK = "WINK",
		YAWN = "THREATEN",
		SEXY = "GRIN",
		CRIES = "VIOLIN",
		LOL = "GUFFAW",
		FLEX = "GOLFCLAP",
		COWER = "CHICKEN",
		SLAP = "BURP",
		KISS = "DROOL",
		HUG = "HELPME",
		POKE = "FART",
		WAVE = "HELLO",
		DANCE = "CRINGE",
	}
end

local function Filter_Menu_Apply(parent, items)
	parent.drop.menu.Update = function(filter)
		parent.filterList = {}
		if filter and ( filter ~= "") then
			for i, b in pairs(parent.buttons) do
				local text = b:GetText()
				if string.find(text, "^"..filter) then
					tinsert(parent.filterList, b)
				end
			end
		end

		for i, b in pairs(parent.buttons) do
			b:Hide()
			b:ClearAllPoints()
			b:SetPoint('TOPLEFT', 0, 0)
		end

		if #parent.filterList > 0  then
			for i, b in pairs(parent.filterList) do
				b:Show()
				b:ClearAllPoints()
				b:SetPoint('TOPLEFT', 0, - ((b:GetHeight() * i) - b:GetHeight()))
				if ( (b:GetHeight() * i) - parent.drop.menu:GetHeight()) > 0 then
					parent.drop.menu.ScrollBar:SetMinMaxValues(0, ( (b:GetHeight() * i) - parent.drop.menu:GetHeight()))
				else
					parent.drop.menu.ScrollBar:SetMinMaxValues(0, 0)
				end
			end
		else
			for i, b in pairs(parent.buttons) do
				b:Show()
				b:ClearAllPoints()
				b:SetPoint('TOPLEFT', 0, - ((b:GetHeight() * i) - b:GetHeight()))
				if ( (b:GetHeight() * i) - parent.drop.menu:GetHeight()) > 0 then
					parent.drop.menu.ScrollBar:SetMinMaxValues(0, ( (b:GetHeight() * i) - parent.drop.menu:GetHeight()))
				else
					parent.drop.menu.ScrollBar:SetMinMaxValues(0, 0)
				end
			end
		end		
	end
end

local Alphabet = {
	"A",
	"B",
	"C",
	"D",
	"E",
	"F",
	"G",
	"H",
	"I",
	"J",
	"K",
	"L",
	"M",
	"N",
	"O",
	"P",
	"Q",
	"R",
	"S",
	"T",
	"U",
	"V",
	"W",
	"X",
	"Y",
	"Z",
}

local Tables = {}

for i, letter in pairs(Alphabet) do
	Tables[i] = {}
end

local temp = {}

for i = 1, 14 do
	temp[i] = {}
end

local ITEMS = {}
local function Filter_Menu_Initialize(parent, items)
	wipe(ITEMS)

	parent.buttons = parent.buttons or {}
	local i = 1
	
	for emote, text in pairs(items) do
		tinsert(ITEMS, emote)
	end

	table.sort(ITEMS)

	for emote, text in pairs(ITEMS) do
		local b = CreateFrame("Button", parent.drop.menu:GetName()..i, parent.drop.menu.child, "UIMenuButtonStretchTemplate")
		b:SetText(text)
		b:SetWidth(120)
		b:SetPoint('TOPLEFT', 0, - (  (b:GetHeight() * i) - b:GetHeight()))
		parent.buttons[i] = b
		parent.drop.menu.child:SetHeight(i*b:GetHeight())
		b:SetScript("OnClick", function() 
			parent.onclick(ITEMS[emote])
			parent.editBox:SetText(ITEMS[emote])
			parent.drop:Hide()
		end)
		i = i + 1
	end
	
	parent.drop.menu.Update = function()
		Filter_Menu_Apply(parent, items)
	end
end

local function NewMenu(name, parent, items)
	local menu = CreateFrame("Button", parent:GetName()..name.."DropDownMenu", parent, "Remote_SearchMenuTemplate")
	Filter_Menu_Initialize(menu, items)
	return menu
end

function REC:Options()
	REC.options = _G["Remote Options"]

	local total = REC.options.panel2:CreateFontString(nil, 'BACKGROUND', 'GameFontNormal')
	total:SetPoint('TOPRIGHT', -15, -15)

	local Temp = {}

	local menu = REC.options

	local trigger, reply = NewMenu("Trigger", menu, Remote_TRIGGERS), NewMenu(REPLY_MESSAGE, menu, Remote_REPLIES)

	function trigger.onclick(value) Temp.trig = value end
	trigger.drop:SetScript("OnShow", function() reply.drop:Hide() end)
	trigger:ClearAllPoints() trigger:SetPoint("TopLeft", -5, -40)

	function reply.onclick(value) Temp.rep = value end
	reply.drop:SetScript("OnShow", function() trigger.drop:Hide() end)
	reply:ClearAllPoints(); reply:SetPoint("TopLeft", 150 - 15, -40)

	local f = CreateFrame("ScrollFrame", REC.options:GetName()..SAVE, REC.options, "UIPanelScrollFrameTemplate")
	f.ScrollBar:ClearAllPoints(); f.ScrollBar:SetPoint("TopRight", f, "TopRight", 0, -15); f.ScrollBar:SetPoint("BottomRight", f, "BottomRight", 0, 12)
	f:SetPoint("TopLeft", 12, -92); f:SetPoint("BottomRight", REC.options, "TopLeft", 290, -290)
	f.Child = CreateFrame("Frame");	f.Child:SetSize(100, 100); f:SetScrollChild(f.Child); f.buttons = {}
	local parent = f

	parent.updateKids = function()
		for i , b in pairs(parent.buttons) do
			b:ClearAllPoints()
		end
		for i , b in pairs(parent.buttons) do
			b:Show()
			b:ClearAllPoints()
			f.Child:SetHeight(i*b:GetHeight())
			local h = b:GetHeight()
			b:SetPoint('TOPLEFT', 0, -( (i*b:GetHeight() ) - b:GetHeight()))
			b:SetScript("OnClick", function() 
				Remote_SV[b.trig] = nil
				for i , b in pairs(parent.buttons) do
					b:Hide()
					b:ClearAllPoints()
				end
				tremove(parent.buttons, i)
				parent.updateKids()
			end)
		end
		total:SetText("Total: "..#parent.buttons)
	end

	local function NewEmoteButton(name, parent)
		local b
		if not _G[name] then
			b = CreateFrame("Button", name, parent, "UIMenuButtonStretchTemplate")
		else
			b  = _G[name]
		end
		b:SetScript("OnEnter", function() 
			GameTooltip:SetOwner(b, 'ANCHOR_TOPLEFT')
			GameTooltip:SetText("Click to delete.")
			GameTooltip:Show()
		end)
		b:SetScript("OnLeave", function() 
			GameTooltip:Hide()
		end)
		return b
	end

	local function UpdateButtons()
		local info = {}
		for i, b in pairs(Remote_SV)do
			tinsert(info, i)
		end
		table.sort(info)
		for i, a in pairs(info) do 
			local b = NewEmoteButton(f:GetName()..i, f.Child, a)
			b:SetText(a.." = "..Remote_SV[a])
			b:SetWidth(b:GetTextWidth() + 10)
			b.trig = a
			parent.buttons[i] = b
			parent.updateKids()
		end
		

	end

	UpdateButtons()

	local accept = CreateFrame("Button", menu:GetName()..ACCEPT, menu, "UIMenuButtonStretchTemplate")
	accept:ClearAllPoints(); accept:SetSize(283, 25); accept:SetPoint("TopLeft", 11, -65); accept:SetText(ACCEPT)
	accept:SetScript("OnClick", function()
		if Temp.trig then
			Remote_SV[Temp.trig] = Temp.rep
			REC:Load_Emotes()
			for i, b in pairs(parent.buttons) do 
				tremove(parent.buttons, i)	
			end
			UpdateButtons()
		end
	end)

	REC:Load_Emotes()

	local Texture = REC.options.panel1

	do
		local opts = REC.options.panel2
		
		local slide = REC:Slider(opts, "Response Delay", 0, 4, .25); slide:SetPoint("TopLeft", 20, -25)
		slide:SetScript("OnShow", function(self, value) self:SetValue(Remote_SETTINGS.delay) end)
		slide:SetScript("OnValueChanged", function(self, value) 
			Remote_SETTINGS.delay = value
			_G[self:GetName() .. 'High']:SetText(Remote_SETTINGS.delay)
		end)

		local ponder = CreateFrame("CheckButton", opts:GetName().."Ponder", opts, "ChatConfigSmallCheckButtonTemplate")
		ponder:SetPoint("BottomLeft", 15, 30); _G[ponder:GetName().."Text"]:SetText("Ponder at Opposing Faction")
		ponder:SetScript("OnShow", function(self) self:SetChecked(Remote_SETTINGS.factionPonder) end)

		local shrug = CreateFrame("CheckButton", opts:GetName().."Shrug", opts, "ChatConfigSmallCheckButtonTemplate")
		shrug:SetPoint("BottomLeft", 15, 15); _G[shrug:GetName().."Text"]:SetText("Shrug at Opposing Faction")
		shrug:SetScript("OnShow", function(self) self:SetChecked(Remote_SETTINGS.factionShrug) end)

		ponder.func = function(self)
			if self:GetChecked() then
				Remote_SETTINGS.faction = "PONDER"
			else
				Remote_SETTINGS.faction = nil
			end
			Remote_SETTINGS.factionPonder = self:GetChecked()
			Remote_SETTINGS.factionShrug = nil
			shrug:SetChecked(false)
		end

		shrug.func = function(self)
			if self:GetChecked() then
				Remote_SETTINGS.faction = "SHRUG"
			else
				Remote_SETTINGS.faction = nil
			end
			Remote_SETTINGS.factionShrug = self:GetChecked()
			Remote_SETTINGS.factionPonder = nil
			ponder:SetChecked(false)
		end
	end
end

do
	local function Slider_OnMouseWheel(self, arg1)
		local step = self:GetValueStep() * arg1
		local value = self:GetValue()
		local minVal, maxVal = self:GetMinMaxValues()
		if step > 0 then
			self:SetValue(min(value+step, maxVal))
		else
			self:SetValue(max(value+step, minVal))
		end
		_G[self:GetName() ..'High']:SetText(self:GetValue())
	end

	function REC:Slider(self, text, low, high, step)
		local name = self:GetName() .. text
		local f = CreateFrame('Slider', name, self, 'OptionsSliderTemplate')
		f:SetScript('OnMouseWheel', Slider_OnMouseWheel)
		f:SetMinMaxValues(low, high)
		f:SetValueStep(step)
		f:EnableMouseWheel(true)

		_G[name .. 'Text']:SetText(text)
		_G[name .. 'Low']:SetText(low)
		_G[name .. 'High']:SetText(high)

		local text = f:CreateFontString(nil, 'BACKGROUND', 'GameFontHighlightSmall')
		text:SetPoint('LEFT', f, 'RIGHT', 7, 0)
		f.valText = text
		return f
	end

end

function REC:Load_Emotes()
	for trigger, reply in pairs(Remote_SV) do
		REC:New(trigger, reply)
	end
end
REC:RegisterEvent("PLAYER_ENTERING_WORLD")
REC:SetScript("OnEvent", REC.Load)
